/*
* Licensed to the Apache Software Foundation (ASF) under one
* or more contributor license agreements.  See the NOTICE file
* distributed with this work for additional information
* regarding copyright ownership.  The ASF licenses this file
* to you under the Apache License, Version 2.0 (the
* "License"); you may not use this file except in compliance
* with the License.  You may obtain a copy of the License at
*
*   http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the License is distributed on an
* "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
* KIND, either express or implied.  See the License for the
* specific language governing permissions and limitations
* under the License.
*/

var exec = require('cordova/exec');
var platform = require('cordova/platform');

var noop = function(){};

function Notification () {

}

Notification.prototype.tips = function (message) {
    var success = noop;
    var fail = noop;
    if(typeof message == 'function'){
        //hdp调用，传了回调
        suc = arguments[0];
        err = arguments[1];
        message = arguments[2];
    }
    var message = (message || "");
    exec(success, fail, 'CDVNotification', 'tips', [message])
}

Notification.prototype.alert = function(message, completeCallback, title, buttonLabel) {
   var suc = noop, err = noop;
   if(typeof message == 'function'){
       //hdp调用，传了回调
       suc = arguments[0];
       err = arguments[1];
       message = arguments[2];
       title = arguments[3];
       buttonLabel = arguments[4];
   } else {
       suc = completeCallback;
   }
   var _title = (title || "");
   var _buttonLabel = (buttonLabel || "OK");
   exec(suc, err, "CDVNotification", "alert", [message, _title, _buttonLabel]);
}

Notification.prototype.confirm = function (message, resultCallback, title, buttonLabels) {
     var suc = noop, err = noop;
     if(typeof message == 'function'){
         //hdp调用，传了回调
         suc = arguments[0];
         err = arguments[1];
         message = arguments[2];
         title = arguments[3];
         buttonLabels = arguments[4];
     } else {
         suc = resultCallback;
     }
     var _title = (title || "");
     var _buttonLabels = (buttonLabels || ["OK", "Cancel"]);

     // Strings are deprecated!
     if (typeof _buttonLabels === 'string') {
         console.log("Notification.confirm(string, function, string, string) is deprecated.  Use Notification.confirm(string, function, string, array).");
     }

     // Some platforms take an array of button label names.
     // Other platforms take a comma separated list.
     // For compatibility, we convert to the desired type based on the platform.
     if (platform.id == "android" || platform.id == "ios" || platform.id == "windowsphone" || platform.id == "blackberry10") {
         if (typeof _buttonLabels === 'string') {
             var buttonLabelString = _buttonLabels;
             _buttonLabels = _buttonLabels.split(","); // not crazy about changing the var type here
         }
     } else {
         if (Array.isArray(_buttonLabels)) {
             var buttonLabelArray = _buttonLabels;
             _buttonLabels = buttonLabelArray.toString();
         }
     }
     exec(suc, err, "CDVNotification", "confirm", [message, _title, _buttonLabels]);
 }
module.exports = new Notification();
